/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author pchr
 */
public class area {
    private Map<Integer,point> thePoints=new HashMap<Integer,point>();
    private Map<Integer,line> AreaLines =new HashMap<Integer,line>();
    private int numOfPoints=0;
    private int numOfLines=0;
    
    public void Area(){}
    
    public void clear(){
        this.thePoints.clear();
        this.AreaLines.clear();
        this.numOfLines=0;
        this.numOfPoints=0;
    }
    
    public void setLines(Map<Integer,line> AreaLines){
        this.AreaLines=AreaLines;
    }
    
    public void setPoints(Map<Integer,point> AreaPoints){
        this.thePoints=AreaPoints;
        numOfPoints+=AreaPoints.size();
    }
    
    public double getIxx(){
        double Ixx=0;
        int n=thePoints.size();
        if(n>0){
            double xiyi1,xi1yi,yipyi12,yiyi1;

            for(int i=1; i<n; i++){
                xiyi1=thePoints.get(i).getc1()*thePoints.get(i+1).getc2();
                xi1yi=thePoints.get(i+1).getc1()*thePoints.get(i).getc2();
                yipyi12=(thePoints.get(i).getc2()+thePoints.get(i+1).getc2())*
                        (thePoints.get(i).getc2()+thePoints.get(i+1).getc2());
                yiyi1=thePoints.get(i).getc2()*thePoints.get(i+1).getc2();
                Ixx+=(xiyi1-xi1yi)*(yipyi12-yiyi1);
            }
            xiyi1=thePoints.get(n).getc1()*thePoints.get(1).getc2();
            xi1yi=thePoints.get(1).getc1()*thePoints.get(n).getc2();
            yipyi12=(thePoints.get(n).getc2()+thePoints.get(1).getc2())*
                    (thePoints.get(n).getc2()+thePoints.get(1).getc2());
            yiyi1=thePoints.get(n).getc2()*thePoints.get(1).getc2();
            Ixx+=(xiyi1-xi1yi)*(yipyi12-yiyi1);
            Ixx/=12.;
        }
        return Ixx;
    }
    
    public double getSx(){
        double Sx=0;
        int n=thePoints.size();
        double xiyi1,xi1yi,yipyi1;
        
        for(int i=1; i<n; i++){
            xiyi1=thePoints.get(i).getc1()*thePoints.get(i+1).getc2();
            xi1yi=thePoints.get(i+1).getc1()*thePoints.get(i).getc2();
            yipyi1=(thePoints.get(i).getc2()+thePoints.get(i+1).getc2());
            Sx+=(xiyi1-xi1yi)*yipyi1;
        }
        xiyi1=thePoints.get(n).getc1()*thePoints.get(1).getc2();
        xi1yi=thePoints.get(1).getc1()*thePoints.get(n).getc2();
        yipyi1=(thePoints.get(n).getc2()+thePoints.get(1).getc2());
        Sx+=(xiyi1-xi1yi)*yipyi1;
        Sx/=6.;
        return Sx;
    }
    
    public double getA(){
        double A=0;
        int n=thePoints.size();
        if(n>0){
            double xiyi1,xi1yi;

            for(int i=1; i<n; i++){
                xiyi1=thePoints.get(i).getc1()*thePoints.get(i+1).getc2();
                xi1yi=thePoints.get(i+1).getc1()*thePoints.get(i).getc2();
                A+=(xiyi1-xi1yi);
            }
            xiyi1=thePoints.get(n).getc1()*thePoints.get(1).getc2();
            xi1yi=thePoints.get(1).getc1()*thePoints.get(n).getc2();
            A+=(xiyi1-xi1yi);
            A/=2.;
        }
        
        return A;
    }
    
    public double getYs(){
        double Ys=0;
        if(thePoints.size()>0){Ys=this.getSx()/this.getA();}
        if(this.getA()<1.e-10){Ys=0.;}
        return Ys;
    }
    
    public double getIxs(){
        double Ixs=0;
        Ixs=this.getIxx()-this.getA()*this.getYs()*this.getYs();
        return Ixs;
    }
    
    public double getIxs(double h){
        double Ixs=0;
        double x=this.getYs()-h;
        Ixs=this.getIxs()+this.getA()*x*x;
        return Ixs;
    }
    
    public double get_h(){
        double h=0.;
        if(thePoints.size()>0){
            double min;
            double max;
            double cur;
            int n=thePoints.size();
            min=thePoints.get(1).getc2();
            max=min;
            for(int i=1; i<n; i++){
                cur=thePoints.get(i).getc2();
                if(cur<min){min=cur;}
                if(cur>max){max=cur;}
            }
            h=max-min;
        }else{h=0.;}
        
        return h;
    }
    
    public double get_b(){
        double b=0.;
        if(thePoints.size()>0){
            double min;
            double cur;
            int n=thePoints.size();
            min=thePoints.get(1).getc1();
            for(int i=1; i<n; i++){
                cur=thePoints.get(i).getc1();
                if(cur<min){min=cur;}
            }
            b=-2.*min;
        }else{b=0.;}
        return b;
    }
    
    public double get_min(){
        double h=0.;
        if(thePoints.size()>0){
            double min;
            double cur;
            int n=thePoints.size();
            min=thePoints.get(1).getc2();
            for(int i=1; i<n; i++){
                cur=thePoints.get(i).getc2();
                if(cur<min){min=cur;}
            }
            h=min;
        }else{h=0.;}
        
        return h;
    }
    
    public double get_max(){
        double h=0.;
        if(thePoints.size()>0){
            double max;
            double cur;
            int n=thePoints.size();
            max=thePoints.get(1).getc2();
            for(int i=1; i<n; i++){
                cur=thePoints.get(i).getc2();
                if(cur>max){max=cur;}
            }
            h=max;
        }else{h=0.;}
        
        return h;
    }
    
    public void putLine(line aline){
        int nln=AreaLines.size()+1;
        this.AreaLines.put(nln, aline);
    }
    
    public void putPoint(point aPoint){
        ++numOfPoints;
        this.thePoints.put(numOfPoints, aPoint);
    }
    
    public Map<Integer,line> getLines(){
        return this.AreaLines;
    }
    
    public Map<Integer,point> getPoints(){
        return this.thePoints;
    }
    
    public void setLines(){
        line aline;
        int curnum=this.numOfPoints;
        if(curnum>1){
            for(int i=1;i<curnum;i++){
            aline= new line(thePoints.get(i),thePoints.get(i+1));
            AreaLines.put(++numOfLines, aline);
            }
            aline= new line(thePoints.get(curnum),thePoints.get(1));
            AreaLines.put(++numOfLines, aline);
        }
        
        
    }
    
    public void printPoints(){
        for(int i=1; i<=this.thePoints.size(); i++){
            
            System.out.print(thePoints.get(i).getId()+" ");
            System.out.print(thePoints.get(i).getc1()+" ");
            System.out.println(thePoints.get(i).getc2());
        }
    }
}
