/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

/**
 *
 * @author pchr
 */
public class line {
    protected point p1;
    protected point p2;
    private static int numLines=0;
    protected int id;
    
    public line(){
    }
    
    public line(point p1, point p2){
        ++numLines;
        this.id=numLines;
        this.p1=p1;
        this.p2=p2;
    }
    
    public int getId(){
        return this.id;
    }
    
    public int getnumLines(){
        return line.numLines;
    }
    
    public point getP1(){
        return this.p1;
    }
    
    public point getP2(){
        return this.p2;
    }
    
    public void clear(){
        line.numLines=0;
    }
    
    public double getL(){
        double L=0.;
        double x1,x2,y1,y2;
        x1=this.p1.getX(); y1=this.p1.getY();
        x2=this.p2.getX(); y2=this.p2.getY();
        L=Math.sqrt( (x2-x1)*(x2-x1)+ (y2-y1)*(y2-y1));
        return L;
    }
    
    public boolean coincidence(Secant anotherLine){
        boolean answer=false;
        double x1,x2,y1,y2;
        x1=this.p1.getX(); y1=this.p1.getY();
        x2=this.p2.getX(); y2=this.p2.getY();
        double x3,x4,y3,y4;
        x3=anotherLine.p1.getX(); y3=anotherLine.p1.getY();
        x4=anotherLine.p2.getX(); y4=anotherLine.p2.getY();
        
        double denominator;
        double numeratorA; double numeratorB;
        
        denominator = (y4-y3)*(x2-x1) - (x4-x3)*(y2-y1);
        numeratorA  = (x4-x3)*(y1-y3) - (y4-y3)*(x1-x3);
        numeratorB  = (x2-x1)*(y1-y3) - (y2-y1)*(x1-x3);
        
        if( (Math.abs(denominator)<=10e-10) &&
            (Math.abs(numeratorA)<=10e-10)  &&
            (Math.abs(numeratorA)<=10e-10)
            ){
            answer=true;
        }
        return answer;
    }
    
    public boolean intersection(Secant anotherLine){
        boolean answer=false;
        double x1,x2,y1,y2;
        x1=this.p1.getX(); y1=this.p1.getY();
        x2=this.p2.getX(); y2=this.p2.getY();
        double x3,x4,y3,y4;
        x3=anotherLine.p1.getX(); y3=anotherLine.p1.getY();
        x4=anotherLine.p2.getX(); y4=anotherLine.p2.getY();
        
        double denominator;
        
        denominator = (y4-y3)*(x2-x1) - (x4-x3)*(y2-y1);
        
        if( (Math.abs(denominator)<=10e-10)){
            answer=true;
        }
        return answer;
    }
    
    public point intersectionPoint(Secant anotherLine){
        point interSectPoint= null;
        double x1,x2,y1,y2;
        x1=this.p1.getX(); y1=this.p1.getY();
        x2=this.p2.getX(); y2=this.p2.getY();
        double x3,x4,y3,y4;
        x3=anotherLine.p1.getX(); y3=anotherLine.p1.getY();
        x4=anotherLine.p2.getX(); y4=anotherLine.p2.getY();
        
        double denominator;
        double numeratorA; double numeratorB;
        
        denominator = (y4-y3)*(x2-x1) - (x4-x3)*(y2-y1);
        numeratorA  = (x4-x3)*(y1-y3) - (y4-y3)*(x1-x3);
        numeratorB  = (x2-x1)*(y1-y3) - (y2-y1)*(x1-x3);
        
        if(Math.abs(denominator)>10e-10){
            double ua,ub;
            ua=numeratorA/denominator;
            ub=numeratorB/denominator;
            interSectPoint = new point(x1+ua*(x2-x1),y1+ua*(y2-y1));
        }
        
        return interSectPoint;
    }
    
    public boolean intersectionInSegment(Secant anotherLine){
        boolean answer=false;
        double x1,x2,y1,y2;
        x1=this.p1.getX(); y1=this.p1.getY();
        x2=this.p2.getX(); y2=this.p2.getY();
        double x3,x4,y3,y4;
        x3=anotherLine.p1.getX(); y3=anotherLine.p1.getY();
        x4=anotherLine.p2.getX(); y4=anotherLine.p2.getY();
        
        double denominator;
        double numeratorA; double numeratorB;
        
        denominator = (y4-y3)*(x2-x1) - (x4-x3)*(y2-y1);
        numeratorA  = (x4-x3)*(y1-y3) - (y4-y3)*(x1-x3);
        numeratorB  = (x2-x1)*(y1-y3) - (y2-y1)*(x1-x3);
        
        if(Math.abs(denominator)>10e-10){
            double ua,ub;
            ua=numeratorA/denominator;
            ub=numeratorB/denominator;
            if(ua>0.0 && ua<1.0) answer=true;
        }
        
        return answer;
    }

}
