/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.swing.JTextArea;
import SecondOrderBisection.domain;

/**
 *
 * @author pchr
 */
public class section {
    private Map<Integer,point> thePoints=new HashMap<Integer,point>();
    private Map<Integer,line> theLines =new HashMap<Integer,line>();
    private Map<Integer,point> theAugmentedPoints = new HashMap<Integer,point>();
    Secant neutral;
    Secant z1up_line;
    Secant z1down_line;
    area A,A1,A2,A3,A4,Aelast;
    private int numPointOfSection=0;
    private int numLinesOfSection=0;
    private material theMaterial;
    private double h1,z1;
    private double curvature;
    private double Moment;
    private double c_height;
    private double hp;
    private int numOfStates=0;
    private Map<Integer,State> theStates=new HashMap<Integer,State>();
    private double My,Mp;
    
    public section(){
        A=new area();
        theMaterial=new material();
        A1=new area();
        A2=new area();
        A3=new area();
        A4=new area();
        Aelast = new area();
    }
    
    public section(double yield, double elast){
        A=new area();
        theMaterial=new material(yield,elast);
    }
    
    public material getMaterial(){
        return this.theMaterial;
    }
    
    
    public void clear(){
        this.theLines.clear();
        this.thePoints.clear();
        this.theStates.clear();
        point apoint = new point();
        apoint.clear();
        line aline = new line();
        aline.clear();
        State aState = new State();
        aState.clear();
    }
    
    public void putPoint(point thePoint){
        ++numPointOfSection;
        thePoints.put(numPointOfSection, thePoint);
    }
    
    public void mirror(){
        point mpoint;
        int curnum= this.numPointOfSection;
        
        for(int i=1;i<=curnum;i++){
            /*if(thePoints.get(curnum-i+1).getX()!=0.0){
                ++numPointOfSection;
                mpoint = new point(-thePoints.get(curnum-i+1).getc1(),thePoints.get(curnum-i+1).getc2());
                thePoints.put(numPointOfSection, mpoint);
            }*/
            ++numPointOfSection;
            mpoint = new point(-thePoints.get(curnum-i+1).getc1(),thePoints.get(curnum-i+1).getc2());
            thePoints.put(numPointOfSection, mpoint);
            
        }
        A.setPoints(thePoints);
    }
    
    public void setLines(){
        line aline;
        int curnum= this.thePoints.size();
        for(int i=1;i<curnum;i++){
            aline= new line(thePoints.get(i),thePoints.get(i+1));
            theLines.put(++numLinesOfSection, aline);
        }
        aline= new line(thePoints.get(curnum),thePoints.get(1));
        theLines.put(++numLinesOfSection, aline);
        A.setLines(theLines);
        
    }
    
    public void printPoints(){
        for(int i=1; i<=this.thePoints.size(); i++){
            
            System.out.print(thePoints.get(i).getId()+" ");
            System.out.print(thePoints.get(i).getc1()+" ");
            System.out.println(thePoints.get(i).getc2());
        }
    }
    
    public void printPoints(JTextArea OutArea){
        OutArea.append("-----------------"+'\n');
        OutArea.append("κόμβοι συνόρου διατομής"+'\n');
        OutArea.append("α/α  y   z"+'\n');
        for(int i=1; i<=this.thePoints.size(); i++){
            
            OutArea.append(thePoints.get(i).getId()+" ");
            OutArea.append(thePoints.get(i).getc1()+" ");
            OutArea.append(thePoints.get(i).getc2()+""+'\n');
        }
        OutArea.append("-----------------"+'\n');
    }
    
    public double getIxx(){
        return this.A.getIxx();
    }
    
    public double getSx(){
        return this.A.getSx();
    }
    
    public double getA(){
        return this.A.getA();
    }
    
    public double getYs(){
        return this.A.getYs();
    }
    
    public double getIxs(){
        return this.A.getIxs();
    }
    
    public double getIxs(double h){
        return this.A.getIxs(h);
    }
    
    public double get_h(){
        return this.A.get_h();
    }
    
    public double get_b(){
        return this.A.get_b();
    }
    
    public int getNumPoints(){
        return this.thePoints.size();
    }
    
    public Map<Integer,line> getLines(){
        return this.theLines;
    }
    
    public Map<Integer,point> getPoints(){
        return this.thePoints;
    }
    
    public Map<Integer,State> getStates(){
        return this.theStates;
    }
    
    public double get_min(){
        return this.A.get_min();
    }
    
     public double get_max(){
        return this.A.get_max();
    }
     
     public Secant setNeutral(double atY){
         point firstP;
         point secondP;
         firstP= new point(20.*this.get_b(),atY);
         secondP= new point(-20.*this.get_b(),atY);
         neutral = new Secant(firstP,secondP);
         
         this.setNeutralIntersections();
         
         return neutral;
     }
     
     public void setNeutralIntersections(){
         for(Iterator<line> it=theLines.values().iterator(); it.hasNext();){
            line theLine = it.next();
            // check intersection
            boolean isIntersected = theLine.intersectionInSegment(neutral);
            // check coincidence
            boolean isConcide = theLine.coincidence(neutral);
            if( isIntersected && !isConcide){
                point apoint=theLine.intersectionPoint(this.neutral);
                neutral.putLine(theLine, apoint);
                //System.out.println(theLine.getId()+" "+apoint.getX()+" "+apoint.getY());
            }
            if(isConcide){
                neutral.putCoincidentLine(theLine);
            }
        }
     }
     
     public Secant setZ1upLine(double atY){
         point firstP;
         point secondP;
         firstP= new point(20.*this.get_b(),atY);
         secondP= new point(-20.*this.get_b(),atY);
         this.z1up_line = new Secant(firstP,secondP);
         
         this.setZ1upIntersections();
         
         return z1up_line;
     }
     
     public Secant setZ1downLine(double atY){
         point firstP;
         point secondP;
         firstP= new point(20.*this.get_b(),atY);
         secondP= new point(-20.*this.get_b(),atY);
         this.z1down_line = new Secant(firstP,secondP);
         
         this.setZ1downIntersections();
         
         return z1down_line;
     }
     
     public void setZ1upIntersections(){
         for(Iterator<line> it=theLines.values().iterator(); it.hasNext();){
            line theLine = it.next();
            // check intersection
            boolean isIntersected = theLine.intersectionInSegment(z1up_line);
            // check coincidence
            boolean isConcide = theLine.coincidence(z1up_line);
            if( isIntersected && !isConcide){
                point apoint=theLine.intersectionPoint(this.z1up_line);
                z1up_line.putLine(theLine, apoint);
                //System.out.println(theLine.getId()+" "+apoint.getX()+" "+apoint.getY());
            }
            if(isConcide){
                z1up_line.putCoincidentLine(theLine);
            }
        }
     }
     
     public void setZ1downIntersections(){
         for(Iterator<line> it=theLines.values().iterator(); it.hasNext();){
            line theLine = it.next();
            // check intersection
            boolean isIntersected = theLine.intersectionInSegment(z1down_line);
            // check coincidence
            boolean isConcide = theLine.coincidence(z1down_line);
            if( isIntersected && !isConcide){
                point apoint=theLine.intersectionPoint(z1down_line);
                z1down_line.putLine(theLine, apoint);
                //System.out.println(theLine.getId()+" "+apoint.getX()+" "+apoint.getY());
            }
            if(isConcide){
                z1down_line.putCoincidentLine(theLine);
            }
        }
     }
     
     public double getMy(JTextArea outArea){
         My=0.;
         double c1=this.get_min();
         double c2=this.get_max();
         double c3=Math.max(Math.abs(this.getYs()-c1), Math.abs(this.getYs()-c2));
         My=10.e-4*this.theMaterial.getSyield()*this.getIxs()/c3;
         outArea.append("μέγιστη απόσταση από την ουδέτερη γραμμή (c [cm]) = "+c3+'\n');
         this.c_height=c3;
         double Elast=theMaterial.getE();
         curvature=theMaterial.getSyield()/(Elast*c3*10.);
         State aState = new State(My,this.getYs(),0.,curvature);
         aState.setType(0);
         aState.setSection(this);
         this.theStates.put(++numOfStates, aState);
         
         return My;
     }
     
     public double getMp(JTextArea outArea){
         Mp=0.;
         //A1 = new area();
         //A4 = new area();
         A1.clear();
         A4.clear();
         for(int i=1;i<=numLinesOfSection;i++){
             line theLine =this.theLines.get(i);
            if(neutral.isInterected(theLine.getId())){
                if( theLine.getP1().getY()>=neutral.getInteresectedPoints().get(theLine.getId()).getY() ){
                    line anotherLine = new line(theLine.getP1(),neutral.getInteresectedPoints().get(theLine.getId()));
                    A1.putPoint(anotherLine.getP1());
                    A1.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                    anotherLine = new line(neutral.getInteresectedPoints().get(theLine.getId()),theLine.getP2());
                    A4.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                }else{
                    line anotherLine = new line(theLine.getP1(),neutral.getInteresectedPoints().get(theLine.getId()));
                    A4.putPoint(anotherLine.getP1());
                    A4.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                    anotherLine = new line(neutral.getInteresectedPoints().get(theLine.getId()),theLine.getP2());
                    A1.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                }
            }else if(neutral.isCoincident(theLine.getId())){
                A1.putPoint(theLine.getP1());
                A4.putPoint(theLine.getP1());
            }else{
                if(theLine.getP1().getY()>neutral.getP1().getY()){
                    A1.putPoint(theLine.getP1());
                }else{
                    A4.putPoint(theLine.getP1());
                }
            }
         }
         A1.setLines();
         A4.setLines();
         
         double lim1,lim2;
         //lim1=this.neutral.getP1().getY();
         /*if(A1.getA()>A4.getA()){
             lim2=this.get_max();
         }else{
             lim2=this.get_min();
         }*/
         lim1=this.get_min();
         lim2=this.get_max();
         int count=0;
         while(Math.abs((A1.getA()-A4.getA()))>=1.e-10){
             if(count>150){
                 outArea.append("επαναλήψεις = "+count+'\n');
                 outArea.append("υπέρβαση μέγιστου αριθμού επαναλήψεων"+'\n');
                 outArea.append("είναι πιθανό τα αποτελέσματα να μην είναι ακριβή"+'\n');
                 break;
             }
             ++count;
             double atY=(lim1+lim2)/2.;
             this.setNeutral(atY);
             //this.setNeutralIntersections();

             //A1 = new area();
             //A4 = new area();
             A1.clear();
             A4.clear();
             for(int i=1;i<=numLinesOfSection;i++){
                 line theLine =this.theLines.get(i);
                 if(neutral.isInterected(theLine.getId())){
                    if( theLine.getP1().getY()>=neutral.getInteresectedPoints().get(theLine.getId()).getY() ){
                        line anotherLine = new line(theLine.getP1(),neutral.getInteresectedPoints().get(theLine.getId()));
                        A1.putPoint(anotherLine.getP1());
                        A1.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                        anotherLine = new line(neutral.getInteresectedPoints().get(theLine.getId()),theLine.getP2());
                        A4.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                    }else{
                        line anotherLine = new line(theLine.getP1(),neutral.getInteresectedPoints().get(theLine.getId()));
                        A4.putPoint(anotherLine.getP1());
                        A4.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                        anotherLine = new line(neutral.getInteresectedPoints().get(theLine.getId()),theLine.getP2());
                        A1.putPoint(neutral.getInteresectedPoints().get(theLine.getId()));
                    }
                }else if(neutral.isCoincident(theLine.getId())){
                    A1.putPoint(theLine.getP1());
                    A4.putPoint(theLine.getP1());
                }else{
                    if(theLine.getP1().getY()>neutral.getP1().getY()){
                        A1.putPoint(theLine.getP1());
                    }else{
                        A4.putPoint(theLine.getP1());
                    }
                }
             }
             A1.setLines();
             A4.setLines();

             if(A1.getA()>A4.getA()){
                 lim1=this.neutral.getP1().getY();
             }else{
                 lim2=this.neutral.getP1().getY();
             }
             
         }
         /*outArea.append("εμβαδό A1 = "+A1.getA()+'\n');
         outArea.append("h A1 = "+A1.get_h()+'\n');
         outArea.append("εμβαδό A4 = "+A4.getA()+'\n');
         outArea.append("h A4 = "+A4.get_h()+'\n');*/
         this.hp=A4.get_h();
         Mp=0.5*this.theMaterial.getSyield()*this.getA();
         Mp*=(Math.abs(this.getYs()-A1.getYs())+Math.abs(A4.getYs()-this.getYs()));
         Mp/=1000.;
         outArea.append("s1= "+Math.abs(this.getYs()-A1.getYs())+'\n'); // added 3/9/08 
         outArea.append("s4= "+Math.abs(A4.getYs()-this.getYs())+'\n'); // added 3/9/08
         
         State aState = new State(Mp,hp+this.get_min(),0.);
         aState.setType(1);
         aState.setSection(this);
         this.theStates.put(++numOfStates, aState);
         
         return Mp;
     }
     
     public void setSubAreas(JTextArea outArea){
         if(this.Moment>this.My){
             double[] x = new double[4];
             x[0]=this.get_min(); x[1]=this.get_max();
             x[2]=1.e-10; x[3]=A.get_h();
             int subs=0; int count=0;
             domain theDomain = new domain();
             boolean check=false;
             while(check==false){
                 ++count;
                 if(count>=15){break;}
                 subs+=2;
                 theDomain = new domain(x,this,subs);
                 theDomain.solve();
                 check=theDomain.getConvergence();

             }
             if(theDomain.getConvergence()){
                 this.z1=theDomain.getSolution()[1];
                 this.h1=theDomain.getSolution()[0];
                 double Elast=theMaterial.getE();
                 curvature=theMaterial.getSyield()/(Elast*z1*10.);
                 State aState = new State(this.Moment,h1,z1,curvature);
                 aState.setSection(this);
                 this.theStates.put(++numOfStates, aState);

             }else{
                 outArea.append(" δεν επετεύχθει σύγκλιση κατά τον υπολογισμό για ροπή "+this.Moment+'\n');
             }             
         }else{
             this.z1=0.;
             this.h1=this.getYs();
             double Elast=theMaterial.getE();
             curvature=100.*this.Moment/(Elast*this.getIxs());
             State aState = new State(this.Moment,h1,z1,curvature);
             aState.setType(3);
             aState.setSection(this);
             this.theStates.put(++numOfStates, aState);
         }

     }
     
     public double getR1(){
         double r1=A2.getA()*Math.abs(h1-A2.getYs())-A3.getA()*Math.abs(h1-A3.getYs())
                 -(A4.getA()-A1.getA())*z1;
         return r1;
     }
     
     public double getR2(){
         double r2=Math.abs(Moment)-this.theMaterial.getSyield()*(
                 A1.getA()*Math.abs(h1-A1.getYs())+A4.getA()*Math.abs(h1-A4.getYs())
                 +Aelast.getIxs(h1)/z1
                 )/1000.;
         return r2;
     }
     
     public void setMoment(double Moment){
         this.Moment=Moment;
     }
     
     public void setSubAreas(double h1_,double z1_){
         A1.clear();
         A4.clear();
         A2.clear();
         A3.clear();
         Aelast.clear();
         
         this.h1=h1_;
         this.z1=z1_;
         
         this.setNeutral(h1);
         this.setZ1downLine(h1-z1);
         this.setZ1upLine(h1+z1);
         this.setAugPoints();
         
         //========================
         for(int i=1;i<=this.theAugmentedPoints.size();i++){
             double y1=this.theAugmentedPoints.get(i).getY();
             double y2=this.z1up_line.getP1().getY();
             double y3=this.neutral.getP1().getY();
             double y4=this.z1down_line.getP1().getY();
             if( y1>=y2 || Math.abs(y1-y2)<1.e-10){
                 A1.putPoint(this.theAugmentedPoints.get(i));
             }
             if( ((y1<=y2)||(Math.abs(y1-y2)<1.e-10)) && ((y1>=y3)||(Math.abs(y1-y3)<1.e-10)) ){
                 A2.putPoint(this.theAugmentedPoints.get(i));
                 Aelast.putPoint(this.theAugmentedPoints.get(i));
             }
             if( ((y1<=y3)||(Math.abs(y1-y3)<1.e-10)) && ((y1>=y4)||(Math.abs(y1-y4)<1.e-10)) ){
                 A3.putPoint(this.theAugmentedPoints.get(i));
                 Aelast.putPoint(this.theAugmentedPoints.get(i));
             }
             if(y1<=y4 || Math.abs(y1-y4)<1.e-10){
                 A4.putPoint(this.theAugmentedPoints.get(i));
             }
         }
         
         A1.setLines();
         A4.setLines();
         A2.setLines();
         A3.setLines();
         Aelast.setLines();
     }
     
     private void setAugPoints(){
         int newNumPoints=0;
         this.theAugmentedPoints.clear();
         //========================
         for(int i=1;i<=numLinesOfSection;i++){
             line theLine =this.theLines.get(i);
             this.theAugmentedPoints.put(++newNumPoints, theLine.getP1());
             if(theLine.getP1().getY()>theLine.getP2().getY()){
                 if(z1up_line.isInterected(theLine.getId())){
                    this.theAugmentedPoints.put(++newNumPoints, z1up_line.getInteresectedPoints().get(theLine.getId()));
                 }
                 if(neutral.isInterected(theLine.getId())){
                    this.theAugmentedPoints.put(++newNumPoints, neutral.getInteresectedPoints().get(theLine.getId()));
                 }
                 if(z1down_line.isInterected(theLine.getId())){
                    this.theAugmentedPoints.put(++newNumPoints, z1down_line.getInteresectedPoints().get(theLine.getId()));
                 }
             }else{
                 if(z1down_line.isInterected(theLine.getId())){
                    this.theAugmentedPoints.put(++newNumPoints, z1down_line.getInteresectedPoints().get(theLine.getId()));
                 }
                 if(neutral.isInterected(theLine.getId())){
                    this.theAugmentedPoints.put(++newNumPoints, neutral.getInteresectedPoints().get(theLine.getId()));
                 }
                 if(z1up_line.isInterected(theLine.getId())){
                    this.theAugmentedPoints.put(++newNumPoints, z1up_line.getInteresectedPoints().get(theLine.getId()));
                 }
             }
             
         }
     }
     
     public void printAugPoints(){
         System.out.println(" Augmn Points");
         System.out.println(z1up_line.getP1().getY());
         System.out.println(neutral.getP1().getY());
         System.out.println(z1down_line.getP1().getY());
        for(int i=1; i<=this.theAugmentedPoints.size(); i++){
            System.out.print(theAugmentedPoints.get(i).getId()+" ");
            System.out.print(theAugmentedPoints.get(i).getc1()+" ");
            System.out.println(theAugmentedPoints.get(i).getc2());
        }
         System.out.println("-------");
    }
     
     public double getMy_val(){
         return this.My;
     }
     
     public double getMp_val(){
         return this.Mp;
     }
     
     public double getz1(){
         return this.z1;
     }
     
     public double geth1(){
         return this.h1;
     }

}
